<template>
  <div>
    <div class="mainPanel row">
      <div><menu-bar /></div>
      <div class="col q-pa-md mainright">
        <!-- info box -->
        <div class="info-box q-pa-sm row">
          <div class="col-8">
            <div class="font-24">
              <b
                >{{ projectData.projectName }} ({{ projectData.shortenURL }})</b
              >
            </div>
            <div>{{ projectData.address }}</div>
            <div v-show="projectData.isPassword == 1">
              Password: {{ projectData.password }}
            </div>
            <div>Start logging time: {{ projectData.dateTime }}</div>
            <div>Data logging duration (s): {{ projectData.duration }}</div>
          </div>
          <div class="col-4" align="right">
            <div v-if="projectData.status == 1">
              <q-btn
                outline
                color="secondary"
                class="btn"
                label="Online"
                no-caps
                @click="changeStatus(0)"
              />
            </div>
            <div v-else>
              <q-btn
                outline
                style="color: red"
                class="btn"
                label="Offline"
                no-caps
                @click="changeStatus(1)"
              />
            </div>
            <div class="q-pt-sm">
              <q-btn
                outline
                class="btn"
                label="Edit"
                color="secondary"
                no-caps
                @click="editBtn()"
              />
            </div>
            <div class="q-pt-sm">
              <q-btn
                outline
                label="Picture"
                color="secondary"
                class="btn"
                no-caps
                @click="pictureBtn()"
              />
            </div>
          </div>
        </div>
        <!-- thumbnail -->
        <div style="width: 80%; margin: auto">
          <div
            class="q-pt-md"
            v-for="(item, index) in pictureData"
            :key="index"
          >
            <div class="box-title row justify-between">
              <div>{{ item.orderID }}-{{ item.label }}</div>
              <div class="row">
                <div class="q-px-md">
                  <q-icon
                    name="fa-solid fa-trash-can"
                    color="secondary"
                    class="cursor-pointer"
                    @click="delPictureIcon(item.picID)"
                  />
                </div>
                <div>
                  <q-icon
                    name="fa-solid fa-file-pen"
                    color="secondary"
                    class="cursor-pointer"
                    @click="editPictureIcon(item.picID, item.orderID)"
                  />
                </div>
              </div>
            </div>
            <div class="box-pic">
              <img :src="convertPic(item.picID)" width="100%" alt="" />
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- edit dialog -->
    <q-dialog v-model="editDia" persistent>
      <q-card class="mainDia q-py-md">
        <div class="q-px-md text-h6">Edit project</div>
        <hr />
        <div class="row q-px-md">
          <div class="col-3 q-pt-sm">Project name:</div>
          <div class="col-8">
            <q-input v-model="project.projectName" dense outlined />
          </div>
        </div>
        <div class="row q-px-md q-pt-md">
          <div class="col-3 q-pt-sm">Shorten URL:</div>
          <div class="col-8">
            <q-input v-model="project.shortenURL" dense outlined />
          </div>
        </div>
        <div class="row q-px-md q-pt-md">
          <div class="col-3 q-pt-sm">
            <q-checkbox v-model="project.isPassword" label="Password:" />
          </div>
          <div class="col-8">
            <q-input
              v-model="project.password"
              :disable="!project.isPassword"
              dense
              outlined
            />
          </div>
        </div>
        <div class="row q-px-md q-pt-md">
          <div class="col-3 q-pt-sm">Address:</div>
          <div class="col-8">
            <q-input v-model="project.address" dense outlined />
          </div>
        </div>
        <div class="row q-px-md q-pt-md">
          <div class="col-3 q-pt-sm">Start logging data:</div>
          <div class="col-8">
            <q-input v-model="project.startLoggingDate" dense outlined />
          </div>
        </div>
        <div class="row q-px-md q-pt-md">
          <div class="col-3 q-pt-sm">Start logging time:</div>
          <div class="col-8">
            <q-input v-model="project.startLoggingTime" dense outlined />
          </div>
        </div>
        <div class="row q-px-md q-pt-md">
          <div class="col-3 q-pt-sm">Logging duration (sec):</div>
          <div class="col-8">
            <q-input v-model="project.duration" dense outlined type="number" />
          </div>
        </div>
        <div class="row q-px-md q-pt-md">
          <div class="col-3 q-pt-sm">Start line number:</div>
          <div class="col-8">
            <q-input
              v-model="project.linenumber"
              dense
              outlined
              type="number"
            />
          </div>
        </div>
        <div class="row justify-center q-pt-md">
          <div>
            <q-btn label="cancel" outline class="btn" @click="editCloseBtn()" />
          </div>
          <div style="width: 40px"></div>
          <div>
            <q-btn
              label="Save"
              class="btn"
              color="secondary"
              @click="editSaveBtn()"
            />
          </div>
        </div>
      </q-card>
    </q-dialog>

    <!-- picture dialog -->
    <q-dialog v-model="pictureDia" persistent>
      <q-card class="mainDia2 q-py-md">
        <div class="q-px-md text-h6">Add new picture</div>
        <hr />
        <div>
          <div class="row q-px-md">
            <div class="col-3 q-pt-sm">Order ID:</div>
            <div class="col-8">
              <q-input v-model="picture.orderID" dense outlined />
            </div>
          </div>
          <div class="row q-px-md q-pt-md">
            <div class="col-3 q-pt-sm">Label:</div>
            <div class="col-8">
              <q-input v-model="picture.label" dense outlined />
            </div>
          </div>
          <div class="row q-px-md q-pt-md">
            <div class="col-3 q-pt-sm">Picture file:</div>
            <div class="col-8">
              <q-input
                v-model="picture.fileName"
                type="file"
                accpet=".jpg"
                dense
                outlined
              />
            </div>
          </div>
          <div class="row justify-center q-pt-md">
            <div>
              <q-btn
                label="cancel"
                outline
                class="btn"
                @click="addPicCloseBtn()"
              />
            </div>
            <div style="width: 40px"></div>
            <div>
              <q-btn
                label="Save"
                class="btn"
                color="secondary"
                @click="addPicSaveBtn()"
              />
            </div>
          </div>
        </div>
      </q-card>
    </q-dialog>

    <!-- delete pic dialog -->
    <q-dialog v-model="confirmDelDia" persistent>
      <q-card class="mainDia3 q-py-md">
        <div class="q-px-md text-h6">Confirm delete</div>
        <hr />
        <div class="q-px-md">Are you want to delete this pictue?</div>
        <div class="row justify-center q-pt-md">
          <div>
            <q-btn label="NO" outline class="btn" @click="delPicCloseBtn()" />
          </div>
          <div style="width: 40px"></div>
          <div>
            <q-btn
              label="YES"
              class="btn"
              color="secondary"
              @click="delPicSaveBtn()"
            />
          </div>
        </div>
      </q-card>
    </q-dialog>

    <!-- edit pic dialog -->
    <q-dialog v-model="editPictureDia" persistent>
      <q-card class="mainDia2 q-py-md">
        <div class="q-px-md text-h6">Picture - {{ editPictureOrderID }}</div>
        <hr />
        <div class="row q-px-md">
          <div class="col-3 q-pt-sm">Order ID:</div>
          <div class="col-8">
            <q-input v-model="editPicture.orderID" dense outlined />
          </div>
        </div>
        <div class="row q-px-md q-py-md">
          <div class="col-3 q-pt-sm">Label:</div>
          <div class="col-8">
            <q-input v-model="editPicture.label" dense outlined />
          </div>
        </div>
        <div class="row q-px-md" v-show="editShowAddFile">
          <div class="col-3 q-pt-sm">Filename:</div>
          <div class="col-8">
            <q-input v-model="editPicture.fileName" dense outlined readonly>
              <template v-slot:append>
                <q-icon
                  name="fa-solid fa-trash-can"
                  class="cursor-pointer"
                  @click="editShowAddFile = false"
                />
              </template>
            </q-input>
          </div>
        </div>
        <div class="row q-px-md" v-show="!editShowAddFile">
          <div class="col-3 q-pt-sm">Filename:</div>
          <div class="col-8">
            <q-input
              v-model="editPicfileName"
              type="file"
              accpet=".jpg"
              dense
              outlined
            />
          </div>
        </div>

        <div class="row justify-center q-pt-md">
          <div>
            <q-btn
              label="cancel"
              outline
              class="btn"
              @click="editPicCloseBtn()"
            />
          </div>
          <div style="width: 40px"></div>
          <div>
            <q-btn
              label="Save"
              class="btn"
              color="secondary"
              @click="editPicSaveBtn()"
            />
          </div>
        </div>
      </q-card>
    </q-dialog>
  </div>
</template>

<script>
import axios from "axios";
<<<<<<< HEAD
=======
import { timingSafeEqual } from "crypto";
>>>>>>> main
import footerBar from "../components/footer.vue";
import menuBar from "../components/sidemenu.vue";
export default {
  components: { footerBar, menuBar },
  data() {
    return {
      key: "",
      projectData: [],
      project: {
        projectName: "",
        shortenURL: "",
        isPassword: true,
        password: "",
        address: "",
        startLoggingDate: "",
        startLoggingTime: "",
        duration: 0,
        linenumber: 0,
      },

      editDia: false,

      pictureDia: false,
      picture: {
        orderID: "",
        label: "",
        fileName: "",
      },
      pictureData: [],

      confirmDelDia: false,
      deleteID: 0,

      editPictureDia: false,
      editPictureID: 0,
      editPictureOrderID: 0,

      editPicture: {
        orderID: "",
        label: "",
        fileName: "",
        picID: "",
      },
      editShowAddFile: true,
      editPicfileName: null,
    };
  },
  methods: {
    // Online btn
    async changeStatus(status) {
      let dataSend = {
        projectID: this.projectData.projectID,
        status: status,
        key: this.key,
      };
      let url = this.apiPath + "changeStatus.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      if (res.data == "logout") {
        this.$q.localStorage.clear();
        this.$router.push("/");
        return;
      } else {
        this.projectData.status = status;
        this.$q.localStorage.set("projectInfo", this.projectData);
        this.loadInfo();
      }
    },

    // edit Btn
    editBtn() {
      this.loadInfo();
      this.editDia = true;
    },
    async editSaveBtn() {
      if (this.project.projectName.length < 6) {
        this.redNotify("Project name is at least 6 characteres.");
        return;
      }
      if (this.project.shortenURL.length < 6) {
        this.redNotify("Shorten URL is at least 6 characteres.");
        return;
      }
      if (this.project.isPassword) {
        if (this.project.password.length < 6) {
          this.redNotify("Password is at least 6 characteres.");
          return;
        }
      }
      if (
        !(
          this.project.address.length > 0 &&
          this.project.startLoggingDate.length > 0 &&
          this.project.startLoggingTime.length > 0 &&
          Number(this.project.duration) > 0 &&
          Number(this.project.linenumber) > 0
        )
      ) {
        this.redNotify("Please input all fields.");
        return;
      }
      let key = this.$q.localStorage.getItem("key");
      let dataSend = {
        key: key,
        ...this.project,
        dateTime:
          this.project.startLoggingDate + " " + this.project.startLoggingTime,
      };
      let url = this.apiPath + "editproject.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      this.$q.localStorage.set("projectInfo", this.project);
      this.loadInfo();
      this.greenNotify("Save complete");
      this.editDia = false;
    },
    editCloseBtn() {
      this.editDia = false;
    },

    //Picture Btn
    pictureBtn() {
      this.pictureDia = true;
      this.picture.orderID = "";
      this.picture.label = "";
      this.picture.fileName = "";
    },
    async addPicSaveBtn() {
      if (this.picture.orderID.length == 0) {
        this.redNotify("Please input order ID.");
        return;
      }
      if (this.picture.label.length == 0) {
        this.redNotify("Please input label.");
        return;
      }
      if (this.picture.fileName.length == 0) {
        this.redNotify("Please input picture file.");
        return;
      }
      let key = this.$q.localStorage.getItem("key");
      const formData = new FormData();
      formData.append("key", key);
      formData.append("orderID", this.picture.orderID);
      formData.append("label", this.picture.label);
      formData.append("fileData", this.picture.fileName[0]);
      formData.append("fileName", this.picture.fileName[0].name);
      formData.append("projectID", this.projectData.projectID);
      const headers = { "Content-Type": "multipart/form-data" };
      let res = await axios.post(this.apiPath + "addPicture.php", formData, {
        headers,
      });
      if (res.data == "logout") {
        this.$q.localStorage.clear();
        this.$router.push("/");
        return;
      } else {
        this.pictureDia = false;
        this.loadPicture();
      }
    },
    addPicCloseBtn() {
      this.pictureDia = false;
    },

    //thumbnail
    convertPic(ID) {
      return (
        this.apiPath +
        "picture/" +
        ID +
        ".jpg?" +
        Math.floor(Math.random() * (999 - 100 + 1) + 100)
      );
    },
    delPictureIcon(ID) {
      this.confirmDelDia = true;
      this.deleteID = ID;
    },
    delPicCloseBtn() {
      this.confirmDelDia = false;
    },
    async delPicSaveBtn() {
      let key = this.$q.localStorage.getItem("key");
      let dataSend = {
        key: key,
        deleteID: this.deleteID,
      };
      let url = this.apiPath + "delPicture.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      if (res.data == "logout") {
        this.$q.localStorage.clear();
        this.$router.push("/");
        return;
      } else {
        this.greenNotify("Delete picture completely");
        this.confirmDelDia = false;
        this.loadPicture();
      }
    },
    async editPictureIcon(ID, orderID) {
      this.editPictureID = ID;
      this.editPictureOrderID = orderID;
      this.editPictureDia = true;
      let dataSend = {
        picID: Number(this.editPictureID),
      };
      let url = this.apiPath + "loadPictureInfo.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      this.editPicture.picID = ID;
      this.editPicture.orderID = res.data[0].orderID;
      this.editPicture.label = res.data[0].label;
      this.editPicture.fileName = res.data[0].fileName;
    },
    editPicCloseBtn() {
      this.editPictureDia = false;
    },
    async editPicSaveBtn() {
      if (!(this.editPicture.orderID && this.editPicture.label)) {
        this.redNotify("Please input all fields.");
        return;
      }
      if (this.editShowAddFile == false) {
        if (this.editPicfileName == null) {
          this.redNotify("Please input picture filename");
          return;
        }
        this.editPicture.fileName = this.editPicfileName[0].name;
      }
      let dataSend = {
        picID: this.editPicture.picID,
        orderID: this.editPicture.orderID,
        label: this.editPicture.label,
        fileName: this.editPicture.fileName,
      };
      let url = this.apiPath + "editPicture.php";
      await axios.post(url, JSON.stringify(dataSend));

      const formData = new FormData();
      formData.append("picID", this.editPicture.picID);
      formData.append("fileData", this.editPicfileName[0]);
      const headers = { "Content-Type": "multipart/form-data" };
      let res = await axios.post(this.apiPath + "updatePicture.php", formData, {
        headers,
      });

      this.loadPicture();
      this.editPictureDia = false;
    },

    //mount fn
    async loadPicture() {
      this.pictureData = [];
      let key = this.$q.localStorage.getItem("key");
      let dataSend = {
        key: key,
        projectID: this.projectData.projectID,
      };
      let url = this.apiPath + "loadPicture.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      if (res.data == "logout") {
        this.$q.localStorage.clear();
        this.$router.push("/");
        return;
      }
      this.pictureData = res.data;
      this.pictureData.sort((a, b) => Number(a.orderID) - Number(b.orderID));
    },
    loadInfo() {
      this.projectData = this.$q.localStorage.getItem("projectInfo");
      this.project = { ...this.projectData };
      this.project.isPassword = this.projectData.isPassword == 1 ? true : false;
      this.project.startLoggingDate = this.projectData.dateTime.split(" ")[0];
      this.project.startLoggingTime = this.projectData.dateTime.split(" ")[1];
      this.key = this.$q.localStorage.getItem("key");
    },
<<<<<<< HEAD
    async checkReport() {
      let key = this.$q.localStorage.getItem("key");
      let dataSend = {
        projectID: Number(this.$route.params.id),
      };
      let url = this.apiPath + "checkReport.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
    },
=======
>>>>>>> main
  },
  mounted() {
    this.loadInfo();
    this.loadPicture();
<<<<<<< HEAD
    this.checkReport();
=======
>>>>>>> main
  },
};
</script>

<style lang="scss" scoped>
.mainPanel {
  color: black;
  max-width: 1400px;
  width: 100%;
  margin: auto;
  font-size: 16px;
  background-color: #f2f2f2;
}
.mainright {
  height: 100vh;
  overflow: auto;
}

.info-box {
  border: 1px solid #837f7f;
  // border: 1px solid red;
  width: 100%;
  height: 155px;
  margin: auto;
}
.btn {
  width: 120px;
}
.mainDia {
  min-width: 800px;
}
.mainDia2 {
  min-width: 600px;
}
.mainDia3 {
  min-width: 400px;
}
.box-title {
  border: 1px solid #c4c4c4;
  height: 40px;
  line-height: 40px;
  padding-left: 10px;
  padding-right: 10px;
}
.box-pic {
  border: 1px solid #c4c4c4;
  font-size: 0px;
}
</style>
